﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="Dynamicweb.Samples.Web.CustomModules.DvkArticles.Admin.Default" ValidateRequest="false" %>
<%@ Register TagPrefix="dw" Namespace="Dynamicweb.Controls" Assembly="Dynamicweb.Controls" %>
<%@ Register Assembly="System.Web.Entity, Version=3.5.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" Namespace="System.Web.UI.WebControls" TagPrefix="asp" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
	<title>Manage articles</title>
	<dw:ControlResources ID="ctrlResources" runat="server" IncludePrototype="true" />
	<% if (false)
		{ // Wrapped in if (false) to get Design Time support in Visual Studio, but no script link in the final HTML. %>
	<script src="../../../prototype-1.6.1.js" type="text/javascript"></script>
	<% } %>
	<script type="text/javascript">
		function selectedArticlesChanged()
		{
			var numberOfSelectedArticles = $$('#articlesTable input[type=checkbox]:checked').length;
			if (numberOfSelectedArticles > 0)
			{
				Ribbon.enableButton('deleteButton');
				Ribbon.enableButton('copyButton');
				Ribbon.tab(2, "myRibbon");
			}
			else
			{
				Ribbon.disableButton('deleteButton');
				Ribbon.disableButton('copyButton');
				Ribbon.tab(1, "myRibbon");
			}
		}

		Event.observe(window, 'load', function ()
		{
			$$('#articlesTable input[type=checkbox]').each(function (el)
			{
				Event.observe(el, 'click', selectedArticlesChanged);
			});

		});
	</script>
</head>
<body>
	<form id="Form1" method="post" runat="server">
	<div>
		<dw:RibbonBar ID="myRibbon" runat="server">
			<dw:RibbonBarTab ID="generalTab" Name="General" runat="server">
				<dw:RibbonBarGroup ID="newItemsGroup" Name="New items" runat="server">
					<dw:RibbonBarButton runat="server" Text="New" Size="Large" Image="AddDocument" ID="newButton" Title="Create new article" OnClientClick="location.href='AddEditArticle.aspx';" />
				</dw:RibbonBarGroup>
			</dw:RibbonBarTab>
			<dw:RibbonBarTab ID="manageTab" Name="Manage" runat="server">
				<dw:RibbonBarGroup ID="toolsGroup" Name="Tools" runat="server">
					<dw:RibbonBarButton Disabled="true" ID="copyButton" Size="Small" Text="Copy" Image="Copy" runat="server" Title="Copy selected articles" EnableServerClick="True" OnClick="copyButton_Click" />
					<dw:RibbonBarButton Disabled="true" ID="deleteButton" Size="Small" Text="Delete" Image="Delete" runat="server" Title="Delete selected articles" EnableServerClick="True" />
				</dw:RibbonBarGroup>
			</dw:RibbonBarTab>
			<dw:RibbonBarTab ID="settingsTab" Name="Settings" runat="server">
				<dw:RibbonBarGroup ID="saveGroup" Name="Save" runat="server">
					<dw:RibbonBarButton ID="saveButton" Text="Save" Image="Save" runat="server" Title="Save settings" EnableServerClick="True" OnClick="saveButton_Click" />
				</dw:RibbonBarGroup>
				<dw:RibbonBarGroup ID="siteSettingsGroup" Name="Site Settings" runat="server">
					<dw:RibbonBarButton ID="introTextButton" runat="server" Text="Intro Text" Size="Small" Image="Tree" Title="Modify the introduction text" OnClientClick="dialog.show('IntroTextDialog');" />
				</dw:RibbonBarGroup>
			</dw:RibbonBarTab>
		</dw:RibbonBar>
		<asp:Repeater ID="ArticleList" runat="server" DataSourceID="EntityDataSource1">
			<HeaderTemplate>
				<table border="0" cellpadding="0" style="width: 600px;" id="articlesTable">
				<tbody>
					<tr>
						<td>
						</td>
						<td style="width: 400px;">
							<strong>Article</strong>
						</td>
						<td style="width: 100px;">
							<strong>Edit</strong>
						</td>
						<td style="width: 100px;">
							<strong>Delete</strong>
						</td>
					</tr>
			</HeaderTemplate>
			<ItemTemplate>
				<tr>
					<td>
						<input id="chk<%# Eval("Id") %>" type="checkbox" value='<%# Eval("Id") %>' name="ArticleId" />
					</td>
					<td>
						<asp:Literal ID="litTitle" runat="server" Text='<%# Eval("Title") %>' />
					</td>
					<td>
						<asp:HyperLink ID="lnkEdit" runat="server" NavigateUrl='<%# "AddEditArticle.aspx?Id=" + DataBinder.Eval(Container.DataItem, "Id") %>'>Edit</asp:HyperLink>
					</td>
					<td>
						<asp:HyperLink ID="lnkDelete" runat="server" NavigateUrl='<%# "DeleteArticle.aspx?Id=" + DataBinder.Eval(Container.DataItem, "Id") %>'>Delete</asp:HyperLink>
					</td>
				</tr>
			</ItemTemplate>
			<FooterTemplate>
				</tbody> </table>
			</FooterTemplate>
		</asp:Repeater>
		<asp:EntityDataSource ID="EntityDataSource1" runat="server" ConnectionString="name=CustomModulesSamplesEntities" DefaultContainerName="CustomModulesSamplesEntities" Where="it.Deleted == false" EntitySetName="Articles" Select="it.[Id], it.[Title]">
		</asp:EntityDataSource>
		<dw:Dialog ID="IntroTextDialog" runat="server" Width="700" Title="Intro text" ShowOkButton="true">
			<dw:Editor ID="IntroText" runat="server" ForceNew="true" Toolbar="FrontendEdit" Width="564" Height="200" />
		</dw:Dialog>
	</div>
	</form>
</body>
</html>
